Skip to content
v2.274.0

CfnRoute L1 construct ​

Specifies a route in a route table. For more information, see Routes in the Amazon VPC User Guide .

You must specify either a destination CIDR block or prefix list ID. You must also specify exactly one of the resources as the target.

If you create a route that references a transit gateway in the same template where you create the transit gateway, you must declare a dependency on the transit gateway attachment. The route table cannot use the transit gateway until it has successfully attached to the VPC. Add a DependsOn Attribute in the AWS::EC2::Route resource to explicitly declare a dependency on the AWS::EC2::TransitGatewayAttachment resource.

Example ​

ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_ec2 as ec2 } from 'aws-cdk-lib';
const cfnRoute = new ec2.CfnRoute(this, 'MyCfnRoute', {
  routeTableId: 'routeTableId',

  // the properties below are optional
  carrierGatewayId: 'carrierGatewayId',
  coreNetworkArn: 'coreNetworkArn',
  destinationCidrBlock: 'destinationCidrBlock',
  destinationIpv6CidrBlock: 'destinationIpv6CidrBlock',
  destinationPrefixListId: 'destinationPrefixListId',
  egressOnlyInternetGatewayId: 'egressOnlyInternetGatewayId',
  gatewayId: 'gatewayId',
  instanceId: 'instanceId',
  localGatewayId: 'localGatewayId',
  natGatewayId: 'natGatewayId',
  networkInterfaceId: 'networkInterfaceId',
  odbNetworkArn: 'odbNetworkArn',
  transitGatewayId: 'transitGatewayId',
  vpcEndpointId: 'vpcEndpointId',
  vpcPeeringConnectionId: 'vpcPeeringConnectionId',
});
python
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_ec2 as ec2

cfn_route = ec2.CfnRoute(self, "MyCfnRoute",
    route_table_id="routeTableId",

    # the properties below are optional
    carrier_gateway_id="carrierGatewayId",
    core_network_arn="coreNetworkArn",
    destination_cidr_block="destinationCidrBlock",
    destination_ipv6_cidr_block="destinationIpv6CidrBlock",
    destination_prefix_list_id="destinationPrefixListId",
    egress_only_internet_gateway_id="egressOnlyInternetGatewayId",
    gateway_id="gatewayId",
    instance_id="instanceId",
    local_gateway_id="localGatewayId",
    nat_gateway_id="natGatewayId",
    network_interface_id="networkInterfaceId",
    odb_network_arn="odbNetworkArn",
    transit_gateway_id="transitGatewayId",
    vpc_endpoint_id="vpcEndpointId",
    vpc_peering_connection_id="vpcPeeringConnectionId"
)
java
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.ec2.*;

CfnRoute cfnRoute = CfnRoute.Builder.create(this, "MyCfnRoute")
        .routeTableId("routeTableId")

        // the properties below are optional
        .carrierGatewayId("carrierGatewayId")
        .coreNetworkArn("coreNetworkArn")
        .destinationCidrBlock("destinationCidrBlock")
        .destinationIpv6CidrBlock("destinationIpv6CidrBlock")
        .destinationPrefixListId("destinationPrefixListId")
        .egressOnlyInternetGatewayId("egressOnlyInternetGatewayId")
        .gatewayId("gatewayId")
        .instanceId("instanceId")
        .localGatewayId("localGatewayId")
        .natGatewayId("natGatewayId")
        .networkInterfaceId("networkInterfaceId")
        .odbNetworkArn("odbNetworkArn")
        .transitGatewayId("transitGatewayId")
        .vpcEndpointId("vpcEndpointId")
        .vpcPeeringConnectionId("vpcPeeringConnectionId")
        .build();
csharp
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.EC2;

var cfnRoute = new CfnRoute(this, "MyCfnRoute", new CfnRouteProps {
    RouteTableId = "routeTableId",

    // the properties below are optional
    CarrierGatewayId = "carrierGatewayId",
    CoreNetworkArn = "coreNetworkArn",
    DestinationCidrBlock = "destinationCidrBlock",
    DestinationIpv6CidrBlock = "destinationIpv6CidrBlock",
    DestinationPrefixListId = "destinationPrefixListId",
    EgressOnlyInternetGatewayId = "egressOnlyInternetGatewayId",
    GatewayId = "gatewayId",
    InstanceId = "instanceId",
    LocalGatewayId = "localGatewayId",
    NatGatewayId = "natGatewayId",
    NetworkInterfaceId = "networkInterfaceId",
    OdbNetworkArn = "odbNetworkArn",
    TransitGatewayId = "transitGatewayId",
    VpcEndpointId = "vpcEndpointId",
    VpcPeeringConnectionId = "vpcPeeringConnectionId"
});
go
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"

cfnRoute := awscdk.Aws_ec2.NewCfnRoute(this, jsii.String("MyCfnRoute"), &CfnRouteProps{
	RouteTableId: jsii.String("routeTableId"),

	// the properties below are optional
	CarrierGatewayId: jsii.String("carrierGatewayId"),
	CoreNetworkArn: jsii.String("coreNetworkArn"),
	DestinationCidrBlock: jsii.String("destinationCidrBlock"),
	DestinationIpv6CidrBlock: jsii.String("destinationIpv6CidrBlock"),
	DestinationPrefixListId: jsii.String("destinationPrefixListId"),
	EgressOnlyInternetGatewayId: jsii.String("egressOnlyInternetGatewayId"),
	GatewayId: jsii.String("gatewayId"),
	InstanceId: jsii.String("instanceId"),
	LocalGatewayId: jsii.String("localGatewayId"),
	NatGatewayId: jsii.String("natGatewayId"),
	NetworkInterfaceId: jsii.String("networkInterfaceId"),
	OdbNetworkArn: jsii.String("odbNetworkArn"),
	TransitGatewayId: jsii.String("transitGatewayId"),
	VpcEndpointId: jsii.String("vpcEndpointId"),
	VpcPeeringConnectionId: jsii.String("vpcPeeringConnectionId"),
})

Initializer ​

ts
new CfnRoute(scope: Construct, id: string, props: CfnRouteProps)
python
CfnRoute(scope: Construct, id: str, props: CfnRouteProps)
java
new CfnRoute(Construct scope, String id, CfnRouteProps props)
csharp
new CfnRoute(Construct scope, string id, CfnRouteProps props)
go
NewCfnRoute(Scope Construct, Id *string, Props CfnRouteProps)

Construct Props ​

carrierGatewayIdoptionalstring | ICarrierGatewayRefcarrier_gateway_idoptionaltyping.Union[str, ICarrierGatewayRef]carrierGatewayIdoptionalStringCarrierGatewayIdoptionalstringCarrierGatewayIdoptionalinterface{}#
The ID of the carrier gateway.

You can only use this option when the VPC contains a subnet which is associated with a Wavelength Zone.

coreNetworkArnoptionalstringcore_network_arnoptionalstrcoreNetworkArnoptionalStringCoreNetworkArnoptionalstringCoreNetworkArnoptional*string#
The Amazon Resource Name (ARN) of the core network.
destinationCidrBlockoptionalstringdestination_cidr_blockoptionalstrdestinationCidrBlockoptionalStringDestinationCidrBlockoptionalstringDestinationCidrBlockoptional*string#
The IPv4 CIDR address block used for the destination match.

Routing decisions are based on the most specific match. We modify the specified CIDR block to its canonical form; for example, if you specify 100.68.0.18/18 , we modify it to 100.68.0.0/18 .

destinationIpv6CidrBlockoptionalstringdestination_ipv6_cidr_blockoptionalstrdestinationIpv6CidrBlockoptionalStringDestinationIpv6CidrBlockoptionalstringDestinationIpv6CidrBlockoptional*string#
The IPv6 CIDR block used for the destination match.

Routing decisions are based on the most specific match.

destinationPrefixListIdoptionalstringdestination_prefix_list_idoptionalstrdestinationPrefixListIdoptionalStringDestinationPrefixListIdoptionalstringDestinationPrefixListIdoptional*string#
The ID of a prefix list used for the destination match.
egressOnlyInternetGatewayIdoptionalstring | IEgressOnlyInternetGatewayRefegress_only_internet_gateway_idoptionaltyping.Union[str, IEgressOnlyInternetGatewayRef]egressOnlyInternetGatewayIdoptionalStringEgressOnlyInternetGatewayIdoptionalstringEgressOnlyInternetGatewayIdoptionalinterface{}#
[IPv6 traffic only] The ID of an egress-only internet gateway.
gatewayIdoptionalstring | IInternetGatewayRef | IVPNGatewayRefgateway_idoptionaltyping.Union[str, IInternetGatewayRef, IVPNGatewayRef]gatewayIdoptionalStringGatewayIdoptionalstringGatewayIdoptionalinterface{}#
The ID of an internet gateway or virtual private gateway attached to your VPC.
instanceIdoptionalstring | IInstanceRefinstance_idoptionaltyping.Union[str, IInstanceRef]instanceIdoptionalStringInstanceIdoptionalstringInstanceIdoptionalinterface{}#
The ID of a NAT instance in your VPC.

The operation fails if you specify an instance ID unless exactly one network interface is attached.

localGatewayIdoptionalstringlocal_gateway_idoptionalstrlocalGatewayIdoptionalStringLocalGatewayIdoptionalstringLocalGatewayIdoptional*string#
The ID of the local gateway.
natGatewayIdoptionalstring | INatGatewayRefnat_gateway_idoptionaltyping.Union[str, INatGatewayRef]natGatewayIdoptionalStringNatGatewayIdoptionalstringNatGatewayIdoptionalinterface{}#
[IPv4 traffic only] The ID of a NAT gateway.
networkInterfaceIdoptionalstringnetwork_interface_idoptionalstrnetworkInterfaceIdoptionalStringNetworkInterfaceIdoptionalstringNetworkInterfaceIdoptional*string#
The ID of a network interface.
odbNetworkArnoptionalstringodb_network_arnoptionalstrodbNetworkArnoptionalStringOdbNetworkArnoptionalstringOdbNetworkArnoptional*string#
The Amazon Resource Name (ARN) of the ODB network.
routeTableIdstring | IRouteTableRefroute_table_idtyping.Union[str, IRouteTableRef]routeTableIdStringRouteTableIdstringRouteTableIdinterface{}required#
The ID of the route table for the route.
transitGatewayIdoptionalstring | ITransitGatewayReftransit_gateway_idoptionaltyping.Union[str, ITransitGatewayRef]transitGatewayIdoptionalStringTransitGatewayIdoptionalstringTransitGatewayIdoptionalinterface{}#
The ID of a transit gateway.
vpcEndpointIdoptionalstringvpc_endpoint_idoptionalstrvpcEndpointIdoptionalStringVpcEndpointIdoptionalstringVpcEndpointIdoptional*string#
The ID of a VPC endpoint.

Supported for Gateway Load Balancer endpoints only.

vpcPeeringConnectionIdoptionalstring | IVPCPeeringConnectionRefvpc_peering_connection_idoptionaltyping.Union[str, IVPCPeeringConnectionRef]vpcPeeringConnectionIdoptionalStringVpcPeeringConnectionIdoptionalstringVpcPeeringConnectionIdoptionalinterface{}#
The ID of a VPC peering connection.

Properties ​

attrCidrBlockstringattr_cidr_blockstrattrCidrBlockStringAttrCidrBlockstringAttrCidrBlock*stringrequired#
The IPv4 CIDR block.
carrierGatewayIdmay be undefinedstringcarrier_gateway_idmay be undefinedstrcarrierGatewayIdmay be undefinedStringCarrierGatewayIdmay be undefinedstringCarrierGatewayIdmay be undefined*string#
The ID of the carrier gateway.
CFN_RESOURCE_TYPE_NAMEstringcfn_resource_type_namestrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*stringrequiredstatic#
The CloudFormation resource type name for this resource class.
Options for this resource, such as condition, update policy etc.
cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*stringrequired#
AWS resource type.
coreNetworkArnmay be undefinedstringcore_network_arnmay be undefinedstrcoreNetworkArnmay be undefinedStringCoreNetworkArnmay be undefinedstringCoreNetworkArnmay be undefined*string#
The Amazon Resource Name (ARN) of the core network.
creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*stringrequired#
destinationCidrBlockmay be undefinedstringdestination_cidr_blockmay be undefinedstrdestinationCidrBlockmay be undefinedStringDestinationCidrBlockmay be undefinedstringDestinationCidrBlockmay be undefined*string#
The IPv4 CIDR address block used for the destination match.
destinationIpv6CidrBlockmay be undefinedstringdestination_ipv6_cidr_blockmay be undefinedstrdestinationIpv6CidrBlockmay be undefinedStringDestinationIpv6CidrBlockmay be undefinedstringDestinationIpv6CidrBlockmay be undefined*string#
The IPv6 CIDR block used for the destination match.
destinationPrefixListIdmay be undefinedstringdestination_prefix_list_idmay be undefinedstrdestinationPrefixListIdmay be undefinedStringDestinationPrefixListIdmay be undefinedstringDestinationPrefixListIdmay be undefined*string#
The ID of a prefix list used for the destination match.
egressOnlyInternetGatewayIdmay be undefinedstringegress_only_internet_gateway_idmay be undefinedstregressOnlyInternetGatewayIdmay be undefinedStringEgressOnlyInternetGatewayIdmay be undefinedstringEgressOnlyInternetGatewayIdmay be undefined*string#
[IPv6 traffic only] The ID of an egress-only internet gateway.
gatewayIdmay be undefinedstringgateway_idmay be undefinedstrgatewayIdmay be undefinedStringGatewayIdmay be undefinedstringGatewayIdmay be undefined*string#
The ID of an internet gateway or virtual private gateway attached to your VPC.
instanceIdmay be undefinedstringinstance_idmay be undefinedstrinstanceIdmay be undefinedStringInstanceIdmay be undefinedstringInstanceIdmay be undefined*string#
The ID of a NAT instance in your VPC.
localGatewayIdmay be undefinedstringlocal_gateway_idmay be undefinedstrlocalGatewayIdmay be undefinedStringLocalGatewayIdmay be undefinedstringLocalGatewayIdmay be undefined*string#
The ID of the local gateway.
logicalIdstringlogical_idstrlogicalIdStringLogicalIdstringLogicalId*stringrequired#
The logical ID for this CloudFormation stack element.

The logical ID of the element is calculated from the path of the resource node in the construct tree.

To override this value, use overrideLogicalId(newLogicalId).

natGatewayIdmay be undefinedstringnat_gateway_idmay be undefinedstrnatGatewayIdmay be undefinedStringNatGatewayIdmay be undefinedstringNatGatewayIdmay be undefined*string#
[IPv4 traffic only] The ID of a NAT gateway.
networkInterfaceIdmay be undefinedstringnetwork_interface_idmay be undefinedstrnetworkInterfaceIdmay be undefinedStringNetworkInterfaceIdmay be undefinedstringNetworkInterfaceIdmay be undefined*string#
The ID of a network interface.
nodeNodenodeNodenodeNodeNodeNodeNodeNoderequired#
The tree node.
odbNetworkArnmay be undefinedstringodb_network_arnmay be undefinedstrodbNetworkArnmay be undefinedStringOdbNetworkArnmay be undefinedstringOdbNetworkArnmay be undefined*string#
The Amazon Resource Name (ARN) of the ODB network.
refstringrefstrrefStringRefstringRef*stringrequired#
Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).

routeRefRouteReferenceroute_refRouteReferencerouteRefRouteReferenceRouteRefRouteReferenceRouteRefRouteReferencerequired#
A reference to a Route resource.
routeTableIdstringroute_table_idstrrouteTableIdStringRouteTableIdstringRouteTableId*stringrequired#
The ID of the route table for the route.
stackStackstackStackstackStackStackStackStackStackrequired#
The stack in which this element is defined.

CfnElements must be defined within a stack scope (directly or indirectly).

transitGatewayIdmay be undefinedstringtransit_gateway_idmay be undefinedstrtransitGatewayIdmay be undefinedStringTransitGatewayIdmay be undefinedstringTransitGatewayIdmay be undefined*string#
The ID of a transit gateway.
vpcEndpointIdmay be undefinedstringvpc_endpoint_idmay be undefinedstrvpcEndpointIdmay be undefinedStringVpcEndpointIdmay be undefinedstringVpcEndpointIdmay be undefined*string#
The ID of a VPC endpoint.
vpcPeeringConnectionIdmay be undefinedstringvpc_peering_connection_idmay be undefinedstrvpcPeeringConnectionIdmay be undefinedStringVpcPeeringConnectionIdmay be undefinedstringVpcPeeringConnectionIdmay be undefined*string#
The ID of a VPC peering connection.

Methods ​

addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string)#
Syntactic sugar for `addOverride(path, undefined)`.
1 parameter

Parameters

  • pathpathpathpathPath — The path of the value to delete.
addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource)deprecated#
Use `addResourceDependency` instead.

This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.

addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource)deprecated#
Use `addResourceDependency` instead.
notes

This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.

This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.

addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{})#
Add a value to the CloudFormation Resource Metadata.
addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{})#
Adds an override to the synthesized CloudFormation resource.
notes · 2 parameters

To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).

If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.

To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.

For example,

typescript
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');

would add the overrides

json
"Properties": {
  "GlobalSecondaryIndexes": [
    {
      "Projection": {
        "NonKeyAttributes": [ "myattribute" ]
        ...
      }
      ...
    },
    {
      "ProjectionType": "INCLUDE"
      ...
    },
  ]
  ...
}

The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.

Parameters

  • pathpathpathpathPath — - The path of the property, you can use dot notation to override values in complex types.
  • valuevaluevaluevalueValue — - The value.
addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string)#
Adds an override that deletes the value of a property from the resource definition.
1 parameter

Parameters

  • propertyPathproperty_pathpropertyPathpropertyPathPropertyPath — The path to the property.
addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{})#
Adds an override to a resource property.

Syntactic sugar for addOverride("Properties.<...>", value).

2 parameters

Parameters

  • propertyPathproperty_pathpropertyPathpropertyPathPropertyPath — The path of the property.
  • valuevaluevaluevalueValue — The value.
addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string)#
Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.
notes

This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.

This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.

applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#
Sets the cross-stack reference strength for this resource.

When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.

1 parameter

Parameters

  • strengthstrengthstrengthstrengthStrength — - The reference strength to use for this resource.
applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions)#
Sets the deletion policy of the resource based on the removal policy specified.
notes

The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.

The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:

cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string#
getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference#
Returns a token for an runtime attribute of this resource.

Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.

1 parameter

Parameters

  • attributeNameattribute_nameattributeNameattributeNameAttributeName — The name of the attribute.
getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{}#
Retrieve a value value from the CloudFormation Resource Metadata.
inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector)#
Examines the CloudFormation resource and discloses attributes.
1 parameter

Parameters

  • inspectorinspectorinspectorinspectorInspector — tree inspector to collect and process attributes.
isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *boolstatic#
Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.

returns

Returns: The construct as a stack element or undefined if it is not a stack element.

isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *boolstatic#
Check whether the given object is a CfnResource.
isCfnRoute(x: any): boolean@staticmethod def is_cfn_route(x: Any) -> boolpublic static Boolean isCfnRoute(Object x)public static bool IsCfnRoute(object x)func IsCfnRoute(X interface{}) *boolstatic#
Checks whether the given object is a CfnRoute.
isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#
Checks if `x` is a construct.
notes · 1 parameter · returns

Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.

Parameters

  • xxxxX — Any object.

Returns: true if x is an object created from a class which extends Construct.

obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{}#
Retrieves an array of resources and stacks this resource depends on.

For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.

overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string)#
Overrides the auto-generated logical ID with a specific ID.
1 parameter

Parameters

  • newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId — The new logical ID to use for this stack element.
removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource)deprecated#
Use `removeResourceDependency` instead

This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.

removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource)#
Indicates that this resource no longer depends on another resource.

This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.

replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource)#
Replaces one dependency with another.
2 parameters

Parameters

  • targettargettargettargetTarget — The dependency to replace.
  • newTargetnew_targetnewTargetnewTargetNewTarget — The new dependency to add.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#
Returns a string representation of this construct.
returns

Returns: a string representation of this resource

with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#
Applies one or more mixins to this construct.

Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.